//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  vector<int> coll;

  INSERT_ELEMENTS(coll,1,9);
  PRINT_ELEMENTS(coll," :\n");

  //     
  reverse (coll.begin(), coll.end());
  PRINT_ELEMENTS(coll,"   :\n");

  //     
  //    
  reverse (coll.begin()+1, coll.end()-1);
  PRINT_ELEMENTS(coll,"   \n   :\n");
  //      
  cout << ToRus("     :\n");
  reverse_copy (coll.begin(), coll.end(),           // 
                ostream_iterator<int>(cout," "));   // 
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------